package eu.eudat.file.transformer.service.wordfiletransformer.word;

import eu.eudat.commonmodels.models.description.DescriptionModel;
import eu.eudat.commonmodels.models.description.PropertyDefinitionModel;
import eu.eudat.commonmodels.models.descriptiotemplate.DescriptionTemplateModel;
import eu.eudat.commonmodels.models.dmp.DmpModel;
import eu.eudat.file.transformer.model.enums.ParagraphStyle;
import eu.eudat.file.transformer.service.wordfiletransformer.visibility.VisibilityService;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.apache.poi.xwpf.usermodel.XWPFParagraph;

import java.io.IOException;
import java.math.BigInteger;

public interface WordBuilder {
	void build(XWPFDocument document, DescriptionTemplateModel descriptionTemplate, PropertyDefinitionModel propertyDefinitionModel, VisibilityService visibilityService) throws IOException;

	XWPFParagraph addParagraphContent(Object content, XWPFDocument mainDocumentPart, ParagraphStyle style, BigInteger numId, int indent);

	int findPosOfPoweredBy(XWPFDocument document);

	void fillFirstPage(DmpModel dmpEntity, DescriptionModel descriptionModel, XWPFDocument document, boolean isDescription);

	void fillFooter(DmpModel dmpEntity, DescriptionModel descriptionModel, XWPFDocument document);
}
